/*
 * This file is part of the QPxTool project.
 * Copyright (C) 2005-2006 Gennady "ShultZ" Kozlov <qpxtool@mail.ru>
 *
 * original version of CD-R(W) manufacturer identification code got from cdrecord, (C) Joerg Schilling
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 *
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <transport.h>
#include "qpx_mmc.h"

const	manuf	mi[]={
	{ { 97, 22, 60 }, "Acer" },
	{ { 97, 45, 20 }, "Acer" },
	{ { 97, 22, 20 }, "Advanced Digital Media" },
	{ { 97, 42, 20 }, "Advanced Digital Media" },
	{ { 97, 25, 50 }, "AMS" },
	{ { 97, 23, 30 }, "AUDIO DISTRIBUTORS" },
	{ { 97, 28, 30 }, "Auvistar" },
	{ { 97, 46, 50 }, "Auvistar" },

	{ { 97, 22, 40 }, "CIS Technology" },
	{ { 97, 45, 40 }, "CIS Technology" },
	{ { 97, 26, 60 }, "CMC Magnetics" },
	{ { 97, 46, 60 }, "CMC Magnetics" },
	{ { 97, 23, 60 }, "Customer Pressing Oosterhout" },

	{ { 97, 28, 50 }, "DELPHI" },
	{ { 97, 27, 00 }, "DIGITAL STORAGE" },
	{ { 97, 48, 40 }, "DIGITAL STORAGE" },
	{ { 97, 23, 10 }, "Doremi" },
	{ { 97, 13, 30 }, "DST" },

	{ { 97, 22, 30 }, "EXIMPO" },

	{ { 97, 26, 00 }, "FORNET" },
	{ { 97, 45, 00 }, "FORNET" },
	{ { 97, 26, 40 }, "FUJI" },
	{ { 97, 46, 40 }, "FUJI" },

	{ { 97, 29, 50 }, "General Magnetics" },
	{ { 97, 28, 10 }, "GIGASTORAGE" },
	{ { 97, 49, 10 }, "GIGASTORAGE" },
	{ { 97, 16, 30 }, "Grand Advance" },
	{ { 97, 31, 30 }, "Grand Advance" },
	{ { 97, 51, 10 }, "Grand Advance" },
	{ { 97, 45, 50 }, "Guann Yinn" },
	{ { 97, 24, 50 }, "Guann Yinn" },

	{ { 97, 24, 60 }, "Harmonic Hall" },
	{ { 97, 29, 00 }, "Harmonic Hall" },
	{ { 97, 29, 30 }, "Hile Optical Disc" },
	{ { 97, 51, 50 }, "Hile Optical Disc" },
	{ { 97, 25, 20 }, "Hitachi Maxell" },
	{ { 97, 47, 10 }, "Hitachi Maxell" },

	{ { 97, 25, 30 }, "INFODISC" },
	{ { 97, 51, 20 }, "INFODISC" },

	{ { 97, 24, 40 }, "kdg mediatech" },
	{ { 97, 28, 40 }, "King Pro" },
	{ { 97, 49, 20 }, "King Pro" },
	{ { 97, 27, 40 }, "Kodak" },
	{ { 97, 48, 10 }, "Kodak" },

	{ { 97, 26, 50 }, "Lead Data" },
	{ { 97, 48, 60 }, "Lead Data" },

	{ { 97, 23, 00 }, "Matsushita" },
	{ { 97, 49, 60 }, "Matsushita" },
	{ { 97, 15, 20 }, "Mitsubishi" },
	{ { 97, 34, 20 }, "Mitsubishi" },
	{ { 97, 50, 20 }, "Mitsubishi" },
	{ { 97, 27, 50 }, "Mitsui" },
	{ { 97, 48, 50 }, "Mitsui" },
	{ { 97, 17, 00 }, "Moser Baer India" },
	{ { 97, 25, 00 }, "MPO" },
	{ { 97, 28, 20 }, "MultiMediaMasters & Machinary" },
	{ { 97, 46, 20 }, "MultiMediaMasters & Machinary" },

	{ { 97, 23, 20 }, "Nacar Media srl" },
	{ { 97, 15, 30 }, "NAN-YA" },

	{ { 97, 28, 00 }, "Opti.Me.S. S.p.A." },
	{ { 97, 49, 30 }, "Opti.Me.S. S.p.A." },
	{ { 97, 21, 40 }, "Optical Disc Manuf." },
	{ { 97, 26, 30 }, "OPTICAL DISC CORPRATION" },
	{ { 97, 23, 50 }, "OPTROM.INC." },

	{ { 97, 27, 30 }, "Pioneer" },
	{ { 97, 48, 30 }, "Pioneer" },
	{ { 97, 27, 10 }, "Plasmon" },
	{ { 97, 48, 20 }, "Plasmon" },
	{ { 97, 26, 10 }, "POSTECH" },
	{ { 97, 47, 40 }, "POSTECH" },
	{ { 97, 27, 20 }, "Princo" },
	{ { 97, 47, 20 }, "Princo" },
	{ { 96, 43, 20 }, "Prodisc" },
	{ { 96, 43, 30 }, "Prodisc" }, // Ritek ?
	{ { 97, 32, 10 }, "Prodisc" },
	{ { 97, 47, 60 }, "Prodisc" },

	{ { 97, 27, 60 }, "Ricoh" },
	{ { 97, 48, 00 }, "Ricoh" },
	{ { 97, 15, 10 }, "Ritek" },
	{ { 97, 31, 00 }, "Ritek" },
	{ { 97, 47, 50 }, "Ritek" },

	{ { 97, 22, 10 }, "Seantram" },
	{ { 97, 16, 20 }, "SHENZEN SG&GAST" },
	{ { 97, 26, 20 }, "SKC" },
	{ { 97, 24, 10 }, "SONY" },
	{ { 97, 46, 10 }, "SONY" },

	{ { 97, 29, 00 }, "Taeil Media" },
	{ { 97, 24, 00 }, "Taiyo Yuden" },
	{ { 97, 46, 00 }, "Taiyo Yuden" },
	{ { 97, 18, 60 }, "TAROKO" },
	{ { 97, 15, 00 }, "TDK Corporation" },
	{ { 97, 32, 00 }, "TDK Corporation" },
	{ { 97, 49, 00 }, "TDK Corporation" },

	{ { 97, 29, 20 }, "UNIDISC" },
	{ { 97, 24, 30 }, "UNITECH" },
	{ { 97, 45, 10 }, "UNITECH" },

	{ { 97, 29, 10 }, "Vanguard" },
	{ { 97, 50, 10 }, "Vanguard" },
	{ { 97, 49, 40 }, "VICTOR" },
	{ { 97, 23, 40 }, "VICTOR" },
	{ { 97, 29, 40 }, "VIVA MAGNETICS" },
	{ { 97, 25, 40 }, "VIVASTAR" },

	{ { 97, 25, 60 }, "Xcitec" },
	{ { 97, 45, 60 }, "Xcitec" },

	{ {  0,  0,  0 }, "UNKNOWN" }
};

typedef struct {
	str_lo	name;
	int	id;
}desc;

#ifdef __FEATURE_DEBUG_

const desc FEATURES[]={
	{ "FEATURE_PROFILE_LIST"		, 0x0000 },
	{ "FEATURE_CORE"			, 0x001 },
	{ "FEATURE_MORPHING"			, 0x002 },
	{ "FEATURE_REMOVABLE_MEDIA"		, 0x003 },
	{ "FEATURE_WRITE_PROTECT"		, 0x004 },
	{ "FEATURE_RANDOM_READABLE"		, 0x010 },
	{ "FEATURE_MULTI_READ"			, 0x01D },
	{ "FEATURE_CD_READ"			, 0x01E },
	{ "FEATURE_DVD_READ"			, 0x01F },
	{ "FEATURE_RANDOM_WRITABLE"		, 0x020 },
	{ "FEATURE_INCREMENTAL_STREAMING_WRITABLE" , 0x021 },
	{ "FEATURE_SECTOR_ERASABLE"		, 0x022 },
	{ "FEATURE_FORMATTABLE"			, 0x023 },
	{ "FEATURE_DEFECT_MANAGEMENT"		, 0x024 },
	{ "FEATURE_WRITE_ONCE"			, 0x025 },
	{ "FEATURE_RESTRICTED_OVERWRITE"	, 0x026 },
	{ "FEATURE_CD_RW_CAV_WRITE"		, 0x027 },
	{ "FEATURE_MRW"				, 0x028 },
	{ "FEATURE_ENHANCED_DEFECT_REPORTING"	, 0x029 },
	{ "FEATURE_DVD_PLUS_RW"			, 0x02A },
	{ "FEATURE_DVD_PLUS_R"			, 0x02B },
	{ "FEATURE_RIGID_RESTRICTED_OVERWRITE"	, 0x02C },
	{ "FEATURE_CD_TRACK_AT_ONCE"		, 0x02D },
	{ "FEATURE_CD_MASTERING"		, 0x02E },
	{ "FEATURE_DVD_R_RW_WRITE"		, 0x02F },
	{ "FEATURE_DDCD_READ"			, 0x030 },
	{ "FEATURE_DDCD_R_WRITE"		, 0x031 },
	{ "FEATURE_DDCD_RW_WRITE"		, 0x032 },
	{ "FEATURE_LAYER_JUMP_RECORDING"	, 0x033 },
	{ "FEATURE_CD_RW_MEDIA_WRITE_SUPPORT" 	, 0x037 },
	{ "FEATURE_DVD_PLUS_R_DOUBLE_LAYER"	, 0x03B },
	{ "FEATURE_BD_READ"			, 0x040 },
	{ "FEATURE_BD_WRITE"			, 0x041 },
//{ "FEATURE_BD_R_POW"	, MMC_BROKEN_FEATURE },
	{ "FEATURE_POWER_MANAGEMENT"		, 0x100 },
	{ "FEATURE_SMART"			, 0x101 },
	{ "FEATURE_EMBEDDED_CHANGER"		, 0x102 },
	{ "FEATURE_CD_AUDIO_ANALOG_PLAY"	, 0x103 },
	{ "FEATURE_MICROCODE_UPGRADE"		, 0x104 },
	{ "FEATURE_TIMEOUT"			, 0x105 },
	{ "FEATURE_DVD_CSS"			, 0x106 },
	{ "FEATURE_REAL_TIME_STREAMING"		, 0x107 },
	{ "FEATURE_LOGICAL_UNIT_SERIAL_NUMBER"	, 0x108 },
	{ "FEATURE_MEDIA_SERIAL_NUMBER"		, 0x109 },
	{ "FEATURE_DISC_CONTROL_BLOCKS"		, 0x10A },
	{ "FEATURE_DVD_CPRM"			, 0x10B },
	{ "FEATURE_FIRMWARE_DATE"		, 0x10C }
//{ "FEATURE_FEATURE_VCPS"		, MMC_BROKEN_FEATURE
	{ "..."					, -1 };
};
#endif //__FEATURE_DEBUG_

const desc PROFILES[]={
	{ "NONE"		, 0x0000 },
	{ "NON_REMOVABLE"	, 0x0001 },
	{ "REMOVABLE"		, 0x0002 },
	{ "MOPTIC_E"		, 0x0003 },
	{ "OPTIC_WO"		, 0x0004 },
	{ "AS_MO"		, 0x0005 },
	{ "CD-ROM"		, 0x0008 },
	{ "CD-R"		, 0x0009 },
	{ "CD-RW"		, 0x000A },
	{ "DVD-ROM"		, 0x0010 },
	{ "DVD-R Sequential"	, 0x0011 },
	{ "DVD-RAM"		, 0x0012 },
	{ "DVD-RW Restricted Overwrite"	, 0x0013 },
	{ "DVD-RW Sequential"	, 0x0014 },
	{ "DVD-R DL Sequential"	, 0x0015 },
	{ "DVD-R DL Layer Jump"	, 0x0016 },
	{ "DVD+RW"		, 0x001A },
	{ "DVD+R"		, 0x001B },
	{ "DVD+R DL"		, 0x002B },
	{ "DD CD-ROM"		, 0x0020 },
	{ "DD CD-R"		, 0x0021 },
	{ "DD CD-RW"		, 0x0022 },
	{ "NO PROFILE"		, 0xFFFF }
};

drive_info::drive_info(){
}

drive_info::drive_info(char* _device){
	device=(char*)malloc(0xFF);
	strcpy(device,_device);
	rd_buf=(char*)malloc(0x10000);
	ATIP=(unsigned char*)malloc(0x0800);
	if (!cmd.associate(device, NULL)) {
//		printf("** Can't open device: %16s\n",_device);
		mmc=-1;
		return;
	}
	mmc=0;
	parms.interval=1;
	parms.tests=0;
	capabilities=0;
	rd_capabilities=0;
	wr_capabilities=0;
	ven_features=0;
	chk_features=0;
	plextor.gigarec=0;
	plextor.varirec_state_cd=0;
	plextor.varirec_pwr_cd=0;
	plextor.varirec_str_cd=0;
	plextor.varirec_state_dvd=0;
	plextor.varirec_pwr_dvd=0;
	plextor.varirec_str_dvd=0;
	plextor.powerec_state=0;
	plextor.plexeraser=0;
	ven_ID=0;
	dev_ID=0;
	iface_id=0;
	iface[0]=0;
	loader_id=0;
	parms.scan_speed_cd=8;
	parms.scan_speed_dvd=5;
	parms.spindown_idx=0;
}

drive_info::~drive_info(){
//	delete urd_buf;
	busy=1;
//	delete pthread_t;
	delete rd_buf;
	delete ATIP;
	delete device;
}

void drivecpy(drive_info* dst, drive_info* src){
	dst->device=(char*)malloc(0xFF);
//		printf("Can't copy device:(\n");
	memcpy(dst->device, src->device,0xFF);
//		printf("Can't copy device:(\n");
//	if (!dst->cmd.associate(dst->device, NULL)) {
//		dst->mmc=-1;
//		printf("Can't copy device:(\n");
//		return;
//	}
	dst->mmc=src->mmc;
//	dst->memcpy(dst, src, 0xFF);
	dst->rd_buf=(char*)malloc(0xFFFF);
	dst->ATIP=(unsigned char*)malloc(0xFFFF);
	dst->ATIP_len = src->ATIP_len;
	dst->ven_ID=src->ven_ID;
	memcpy(dst->ven,src->ven,9);
	dst->dev_ID=src->dev_ID;
	memcpy(dst->dev,src->dev,17);
	memcpy(dst->fw,src->fw,5);
	memcpy(dst->serial,src->serial,17);
	memcpy(dst->TLA,src->TLA,5);
	dst->buffer_size = src->buffer_size;
	dst->capabilities = src->capabilities;
	dst->rd_capabilities = src->rd_capabilities;
	dst->wr_capabilities = src->wr_capabilities;
	dst->ven_features = src->ven_features;
	dst->chk_features = src->chk_features;

	dst->iface_id = src->iface_id;
	memcpy(dst->iface,src->iface,sizeof(str_if));
	dst->loader_id = src->loader_id;

	dst->book_plus_r = src->book_plus_r;
	dst->book_plus_rw = src->book_plus_rw;
	dst->book_plus_rdl = src->book_plus_rdl;

	memcpy(&(dst->plextor),&(src->plextor),sizeof(plex_features));
	memcpy(&(dst->astrategy),&(src->astrategy),sizeof(plex_as));
	memcpy(&(dst->plextor_silent),&(src->plextor_silent),sizeof(plex_silent));
	memcpy(&(dst->media),&(src->media),sizeof(media_info));
	memcpy(&(dst->parms),&(src->parms),sizeof(drive_parms));
	memcpy(&(dst->perf),&(src->perf),sizeof(perf_desc));
//	memcpy(dst->,src->,sizeof());

	dst->parms.tests = src->parms.tests;
	dst->parms.interval = src->parms.interval;
	dst->parms.scan_speed_cd = src->parms.scan_speed_cd;
	dst->parms.scan_speed_dvd = src->parms.scan_speed_dvd;
		
// 	dst->media.type = src->media.type;
//	memcpy(dst->media.MID,src->media.MID,32);
//	dst->media.disc_type = src->media.disc_type;
//	dst->media.book_type = src->media.book_type;
//	dst->media.layers = src->media.layers;
//	dst->media.capacity = src->media.capacity;
}

void drive_info::cmd_clear(){
	for (int i=0; i<12; i++) cmd[i]=0;
}

/*
bool drive_info::lock(){
	if (!busy) {busy=true; return true; }
	else { return false; }
}

bool drive_info::unlock(){
	busy=false;
	return true;
}

bool drive_info::isBusy(){
	return busy;
}

void drive_info::wait_free(){
	while (busy);
}
*/

void SpinUpCD(drive_info* drive) {
	for (int i=64; i>0; i--) read(drive, i*15, 15);
}

void SpinUpDVD(drive_info* drive) {
	for (int i=192; i>0; i--) read(drive, i*8, 8);
}

int inquiry(drive_info* drive) {
	char	data[36];	
	if (drive->mmc == -1) return ERR_NO_DEV;
	drive->cmd_clear();
	drive->cmd[0] = MMC_INQUIRY;
	drive->cmd[4] = 36;
	drive->cmd[5] = 0;
	drive->err=drive->cmd.transport(READ,data,36);
	if (drive->err) return ERR_NO_SCSI;
	memcpy(drive->ven,data+8,8);
	drive->ven[8] = 0;
	memcpy(drive->dev,data+16,16);
	drive->dev[16] = 0;
	memcpy(drive->fw,data+32,4);
	drive->fw[4] = 0;
	if ((data[0]&0x1F) != 5) return ERR_NO_MMC;
	drive->mmc=1;
	return 0;
}

int test_unit_ready(drive_info* drive) {
	drive->cmd_clear();
	drive->cmd[0] = MMC_TEST_UNIT_READY;
	if ((drive->err=drive->cmd.transport(READ, NULL, 0) )) return drive->err;
	return 0;
}

int request_sense(drive_info* drive, char add){
	drive->cmd_clear();
	drive->cmd[0]= MMC_REQUEST_SENSE;
	drive->cmd[4]= 0x12+add;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,0x12) ))
		{sperror ("REQUEST_SENSE",drive->err); return (drive->err); }
	return 0;
}

/*
int mode_sense6(drive_info* drive, int page, int page_control, short dest_len) {
	drive->cmd_clear();
	drive->cmd[0]=MMC_MODE_SENSE6;
	drive->cmd[1]= 0x10;
	drive->cmd[2]=page_control << 6 | page;
	drive->cmd[4]=dest_len & 0xFF;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,dest_len) ))
		{sperror ("MODE_SENSE(6)",drive->err); return (drive->err); }
	return 0;
}
*/
int mode_sense(drive_info* drive, int page, int page_control, int dest_len) {
	drive->cmd_clear();
	drive->cmd[0]=MMC_MODE_SENSE10;
	drive->cmd[2]=page_control << 6 | page;
	drive->cmd[7]=(dest_len >> 8) & 0xFF;
	drive->cmd[8]=dest_len & 0xFF;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,dest_len) ))
		{sperror ("MODE_SENSE(10)",drive->err); return (drive->err); }
	return 0;
}
/*
int mode_select6(drive_info* drive, short dest_len) {
	drive->cmd_clear();
	drive->cmd[0]=MMC_MODE_SELECT6;
//	drive->cmd[1]= 0x10;
	drive->cmd[4]=dest_len & 0xFF;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,dest_len) ))
		{sperror ("MODE_SELECT(6)",drive->err); return (drive->err); }
	return 0;
}
*/
int mode_select(drive_info* drive, int dest_len) {
	drive->cmd_clear();
	drive->cmd[0]=MMC_MODE_SELECT10;
	drive->cmd[1]= 0x10;
	drive->cmd[7]=(dest_len >> 8) & 0xFF;
	drive->cmd[8]=dest_len & 0xFF;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,dest_len) ))
		{sperror ("MODE_SELECT(10)",drive->err); return (drive->err); }
	return 0;
}

int get_configuration(drive_info* drive, int feature_number, char* data_length, int* current) {
	if (data_length) *data_length = 0;
	if (current) *current = 0;
	drive->cmd_clear();
	drive->cmd[0] = MMC_GET_CONFIGURATION;
	drive->cmd[1] = 0x02;
	drive->cmd[2] = (feature_number >> 8) & 0xFF;
	drive->cmd[3] = feature_number & 0xFF;
	drive->cmd[7] = 0;
	drive->cmd[8] = 8;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,8)))
		{sperror ("GET_CONFIGURATION",drive->err);
		return (drive->err);}
	if (data_length)
	{
		*data_length = (drive->rd_buf[0]<<24) | (drive->rd_buf[1]<<16) | (drive->rd_buf[2]<<8) | drive->rd_buf[3];
		drive->cmd[7] = ((*data_length+4) >> 8) & 0xFF;
		drive->cmd[8] = (*data_length+4) & 0xFF;
		if (*data_length > 4)
			if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,*data_length+4)))
				{sperror ("GET_CONFIGURATION",drive->err);
				return (drive->err);}
	}
	if (current) *current = drive->rd_buf[10] & 0x01;	
	return 0;
}

void detect_iface(drive_info* drive){
	char len=0;
	get_configuration(drive, FEATURE_CORE, &len, NULL);
	drive->iface_id= (drive->rd_buf[12] << 12) | (drive->rd_buf[13] << 8) | (drive->rd_buf[14] << 4) | drive->rd_buf[15];
	if (drive->iface_id<iface_id_max)
		strcpy(drive->iface,iface_list[drive->iface_id]);
	else
		strcpy(drive->iface,iface_list[iface_id_max+1]);
}

void detect_capabilities(drive_info* drive){
	char	len=4;
	drive->capabilities=CAP_SET_CD_SPEED;
	drive->rd_capabilities=0;
	drive->wr_capabilities=0;
	detect_mm_capabilities(drive);
	if (drive->mmc>1) {
		// LU is MMC2 or later. Detecting capabilities by GET_CONFIGURATION
		get_profiles(drive);
		get_configuration(drive, FEATURE_REMOVABLE_MEDIA , &len, NULL);
		if (len >= 0x0C) drive->capabilities|=CAP_REMOVABLE_MEDIA;
		get_configuration(drive, FEATURE_SMART , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_SMART;
		get_configuration(drive, FEATURE_MICROCODE_UPGRADE , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_MICROCODE_UPGRADE;
		get_configuration(drive, FEATURE_MORPHING , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_MORPHING;
		get_configuration(drive, FEATURE_POWER_MANAGEMENT , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_POWER_MANAGEMENT;
		get_configuration(drive, FEATURE_EMBEDDED_CHANGER , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_EMBEDDED_CHANGER;
		get_configuration(drive, FEATURE_DEFECT_MANAGEMENT , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_DEFECT_MANAGEMENT;
		get_configuration(drive, FEATURE_REAL_TIME_STREAMING , &len, NULL);
		if (len >= 0x08) drive->capabilities|=CAP_REAL_TIME_STREAMING;
		get_configuration(drive, FEATURE_MRW , &len, NULL);
		if (len >= 0x0C) {
			drive->rd_capabilities|=DEVICE_MRW;
			if (drive->rd_buf[12]&0x01) drive->wr_capabilities|=DEVICE_MRW;
		}
		get_configuration(drive, FEATURE_CD_READ , &len, NULL); // LU can Reed/Write CD's
		if (len >= 0x0C) {
//			drive->rd_capabilities|=DEVICE_CD_ROM;
			if (drive->rd_buf[12]&0x1) drive->capabilities|=CAP_CD_TEXT;
			if (drive->rd_buf[12]&0x2) drive->capabilities|=CAP_C2;
		}
		get_configuration(drive, FEATURE_DVD_READ , &len, NULL); // LU can Reed/Write DVD's
		if (len >= 0x08) {
			if (drive->rd_buf[14]&0x01) drive->rd_capabilities|=DEVICE_DVD_R_DL;
			get_configuration(drive, FEATURE_DVD_CPRM , &len, NULL);
			if (len >= 0x08) drive->capabilities|=CAP_DVD_CPRM;
			get_configuration(drive, FEATURE_DVD_CSS , &len, NULL);
			if (len >= 0x08) drive->capabilities|=CAP_DVD_CSS;
			get_configuration(drive, FEATURE_DVD_R_RW_WRITE , &len, NULL);
			if (len >= 0x08) {
				drive->wr_capabilities|=DEVICE_DVD_R;
				if (drive->rd_buf[12]&0x02) drive->wr_capabilities|=DEVICE_DVD_RW;
				if (drive->rd_buf[12]&0x04) drive->wr_capabilities|=DEVICE_DVD_R_DL;
			}
			get_configuration(drive, FEATURE_LAYER_JUMP_RECORDING , &len, NULL);
			if (len >= 0x08) drive->wr_capabilities|=DEVICE_DVD_R_DL;

			get_configuration(drive, FEATURE_DVD_PLUS_R , &len, NULL);
			if (len >= 0x08) {
// 				drive->mmc=4;
				drive->rd_capabilities|=DEVICE_DVD_PLUS_R;
				if (drive->rd_buf[12]&0x01) drive->wr_capabilities|=DEVICE_DVD_PLUS_R;
			}
			get_configuration(drive, FEATURE_DVD_PLUS_RW , &len, NULL);
			if (len >= 0x0C) {
				drive->rd_capabilities|=DEVICE_DVD_PLUS_RW;
				if (drive->rd_buf[12]&0x01) drive->wr_capabilities|=DEVICE_DVD_PLUS_RW;
			}
			get_configuration(drive, FEATURE_DVD_PLUS_R_DOUBLE_LAYER , &len, NULL);
			if (len >= 0x0C) {
// 				drive->mmc=5;
				drive->rd_capabilities|=DEVICE_DVD_PLUS_R_DL;
				if (drive->rd_buf[12]&0x01) drive->wr_capabilities|=DEVICE_DVD_PLUS_R_DL;
			}
		}
		get_configuration(drive, FEATURE_DDCD_READ , &len, NULL);  // LU can Reed/Write DDCD's
		if (len >= 0x0C) {
			drive->rd_capabilities|=DEVICE_DDCD_R;
			drive->rd_capabilities|=DEVICE_DDCD_RW;
			get_configuration(drive, FEATURE_DDCD_R_WRITE , &len, NULL);
			if (len >= 0x0C) drive->wr_capabilities|=DEVICE_DDCD_R;
			get_configuration(drive, FEATURE_DDCD_RW_WRITE , &len, NULL);
			if (len >= 0x0C) drive->wr_capabilities|=DEVICE_DDCD_RW;
		}
	printf("** Device is MMC-%d\n",drive->mmc);
	}
}

int get_profiles(drive_info* drive) {
	char len;
	printf("Reading supported profiles...\n");
	if (get_configuration(drive, FEATURE_PROFILE_LIST , &len, NULL)) return 1;
	for( int j = 0; j < len-8; j+=4 ) {
		short profile = drive->rd_buf[12+j]<<8 | drive->rd_buf[13+j];
		int i=0;
		while ((PROFILES[i].id != profile) && (PROFILES[i].id < 0xFFFF)) i++;
		printf("Profile: 0x%02X%02X [%s]\n",drive->rd_buf[12+j],drive->rd_buf[13+j], PROFILES[i].name);

/*
		switch (profile) {
			case 0x10:						// DVD-ROM
//				drive->rd_capabilities |= DEVICE_DVD_ROM;
				break;
			case 0x11:						// DVD-R Sequential
//				drive->rd_capabilities |= DEVICE_DVD_R;
				break;
			case 0x12:						// DVD-RAM
//				drive->rd_capabilities |= DEVICE_DVD_RAM;
				break;
			case 0x13:						// DVD-RW Restricted Overwrite
//				drive->rd_capabilities |= DEVICE_DVD_RW;
				break;
			case 0x14:
//				drive->rd_capabilities |= DEVICE_DVD_RW;
				break;		// DVD-RW Sequential
			case 0x15:						// DVD-R DL Sequential
//				drive->rd_capabilities |= (DEVICE_DVD_R|DEVICE_DVD_R_DL);
//				drive->wr_capabilities |= (DEVICE_DVD_R|DEVICE_DVD_R_DL);
				break;
			case 0x16:						// DVD-R DL Layer Jump
//				drive->rd_capabilities |= (DEVICE_DVD_R|DEVICE_DVD_R_DL);
//				drive->wr_capabilities |= (DEVICE_DVD_R|DEVICE_DVD_R_DL);
				break;
			case 0x1A:						// DVD+RW
//				drive->rd_capabilities |= DEVICE_DVD_PLUS_RW;
				break;
			case 0x1B:						// DVD+R
//				drive->rd_capabilities |= DEVICE_DVD_PLUS_R;
				break;
			case 0x2B:						// DVD+R DL
//				drive->rd_capabilities |= (DEVICE_DVD_PLUS_R|DEVICE_DVD_PLUS_R_DL);
				break;
			case 0x08:						// CD-ROM
//				drive->rd_capabilities |= DEVICE_CD_ROM;
				break;
			case 0x09:						// CD-R
//				drive->rd_capabilities |= DEVICE_CD_R;
				break;
			case 0x0A:						// CD-RW
//				drive->rd_capabilities |= DEVICE_CD_RW;
				break;
		}
*/
	}
	return 0;
}

int read_atip(drive_info* drive) {
	unsigned char	data[4];
	int 	size = 0;
	int	i;
	drive->ATIP_len = 0;
	drive->cmd_clear();
	drive->cmd[0]=MMC_READ_TOC_PMA_ATIP;
	drive->cmd[1]=0;
	drive->cmd[2]=4;
	drive->cmd[3]=0;
	drive->cmd[8]=4;
	if ((drive->err=drive->cmd.transport(READ,data,4) ))
		{sperror ("READ_ATIP",drive->err); return 1;}
	size = swap2u((char*)data);
	drive->cmd_clear();
	drive->cmd[0]=MMC_READ_TOC_PMA_ATIP;
	drive->cmd[1]=0;
	drive->cmd[2]=4;
	drive->cmd[3]=0;
	drive->cmd[7]=(size >> 8) & 0xFF;
	drive->cmd[8]=size & 0xFF;
	if ((drive->err=drive->cmd.transport(READ,drive->ATIP,size) ))
		{sperror ("READ_ATIP",drive->err); return 1;}
	drive->ATIP_len = size;
	printf("ATIP (%d bytes):",size);
	for (i=0; i<size; i++) {
		if (!(i % 16)) printf("\n");
		printf(" %3d(0x%02X)",drive->ATIP[i],drive->ATIP[i]);
	}
	printf("\n");
	return 0;
}

int read_capacity(drive_info* drive) {
	unsigned char data[8]; memset(data, 0, 8);
	unsigned int ccity,bsize;
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_RECORDED_CAPACITY;
	drive->cmd[9] = 0;
	drive->cmd.transport (READ,data,8);
	ccity = data[0]<<24|data[1]<<16|data[2]<<8|data[3], ccity++;
        bsize = data[4]<<24|data[5]<<16|data[6]<<8|data[7];
	drive->media.capacity = ccity; //capacity in blocks
	lba2msf(&drive->media.capacity,&drive->media.capacity_msf);
	drive->media.sectsize = bsize; //block size
        return 0;
}

int read_track_info(drive_info* drive, track_info* track){
	int size = 2048;
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_TRACK_INFORMATION;
	drive->cmd[1] = 0x01;
	drive->cmd[2] = (track->n >> 24) & 0xFF;
	drive->cmd[3] = (track->n >> 16) & 0xFF;
	drive->cmd[4] = (track->n >> 8) & 0xFF;
	drive->cmd[5] = track->n & 0xFF ;
	drive->cmd[7] = (size >> 8) & 0xFF ;
	drive->cmd[8] = size & 0xFF ;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,size) ))
		{sperror ("READ_TRACK_INFO",drive->err); return 1;}
	
//	int i,
	int len;
	len = ( drive->rd_buf[0] << 8 ) | drive->rd_buf[1];
/*	printf("\nTrack #%d info:\n  ",track->n);
	for (i=0; i<len+2; i++) { printf(" 0x%02X",drive->rd_buf[i] & 0xFF); if (!((i+1)%8)) printf("\n  ");}
	if (((i)%8)) printf("\n");*/

	track->n = ((drive->rd_buf[32]&0xFF) << 8) | (drive->rd_buf[2]&0xFF);
	track->session = ((drive->rd_buf[33]&0xFF) << 8) | (drive->rd_buf[3]&0xFF);
	track->track_mode = drive->rd_buf[5] & 0x0F;
	track->data_mode = drive->rd_buf[6] & 0x0F;
	track->start = ((drive->rd_buf[8]&0xFF) << 24) | ((drive->rd_buf[9]&0xFF) << 16) |
		((drive->rd_buf[10]&0xFF) << 8) | (drive->rd_buf[11]&0xFF);
	track->next_writable = ((drive->rd_buf[12]&0xFF) << 24) | ((drive->rd_buf[13]&0xFF) << 16) |
		((drive->rd_buf[14]&0xFF) << 8) | (drive->rd_buf[15]&0xFF);
	track->free = ((drive->rd_buf[16]&0xFF) << 24) | ((drive->rd_buf[17]&0xFF) << 16) |
		((drive->rd_buf[18]&0xFF) << 8) | (drive->rd_buf[19]&0xFF);
	track->size = ((drive->rd_buf[24]&0xFF) << 24) | ((drive->rd_buf[25]&0xFF) << 16) |
		((drive->rd_buf[26]&0xFF) << 8) | (drive->rd_buf[27]&0xFF);
	track->last_recorded = ((drive->rd_buf[28]&0xFF) << 24) | ((drive->rd_buf[29]&0xFF) << 16) |
		((drive->rd_buf[30]&0xFF) << 8) | (drive->rd_buf[31]&0xFF);
	track->end = track->start+track->size-1;

	lba2msf(&track->start,&track->msf_start);
	lba2msf(&track->next_writable,&track->msf_next);
	lba2msf(&track->last_recorded,&track->msf_last);
	lba2msf(&track->end,&track->msf_end);
	lba2msf(&track->size,&track->time);

	printf("\nTrack #  : %d\n",track->n);
	printf("Session #: %d\n",track->session);
	printf("Track mode    : %d\n",track->track_mode);
	printf("Data mode     : %d\n",track->data_mode);
	printf("Track start   : %d\n",track->start);
	printf("Next writable : %d\n",track->next_writable);
	printf("Free          : %d\n",track->free);
	printf("Size          : %d\n",track->size);
	printf("Last recorded : %d\n",track->last_recorded);
	return 0;
}

int read_free(drive_info* drive) {
	track_info track;
	if (drive->media.dstatus == 2) {
		drive->media.capacity_free = 0;
		return 0;
	}
	if (drive->media.disc_type & DISC_CD) {
		if (((drive->media.last_lead_out >> 24) & 0xFF ) == 0xFF) {
			drive->media.capacity_free = 0;
			return 0;
		} else {
			drive->media.capacity_free = drive->media.last_lead_out - drive->media.capacity - 150;
			lba2msf(&drive->media.capacity_free,&drive->media.capacity_free_msf);
			return 0;
		}
	} else if (drive->media.disc_type & DISC_DVD) {
		track.n = drive->media.sessions+1;
		read_track_info(drive, &track);
		drive->media.capacity_free = track.free;
		return 0;
	}
	drive->media.capacity_free = 0;
	return 1;
}

int read_disc_information(drive_info* drive) {
	int i,len;
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_DISC_INFORMATION;
	drive->cmd[7] = 0x08;
	drive->cmd[8] = 0x00;
	drive->cmd.transport (READ,drive->rd_buf,2048);
	len= (drive->rd_buf[0]<<8)|drive->rd_buf[1];
	printf("Disc info length: 0x%04X\n  ",len);
	if (len!=0x20) {
		drive->media.erasable = 0;
		drive->media.dstatus = 0;
		drive->media.sstatus = 0;
		drive->media.sessions = 0;
		drive->media.tracks = 0;
		return 1;
	}
	for (i=0; i<len+2; i++) {
		printf(" 0x%02X",drive->rd_buf[i] & 0xFF);
		if (!((i+1)%8)) printf("\n  ");
	}
	if (((i)%8)) printf("\n");
	drive->media.erasable = (drive->rd_buf[2]&0x10);
	drive->media.dstatus = drive->rd_buf[2]&0x03;
	drive->media.sstatus = (drive->rd_buf[2]>>2)&0x03;
	drive->media.sessions = (drive->rd_buf[4]|(drive->rd_buf[9]<<8));
// 	if (!drive->media.sstatus) drive->media.sessions--;
	printf("   first track# on disc: %d\n", drive->rd_buf[3]);
	printf("   first track# in last session: %d\n", drive->rd_buf[5]|(drive->rd_buf[10]<<8));
	drive->media.tracks = drive->rd_buf[6]|(drive->rd_buf[11]<<8);
	printf("   last  track# in last session: %d\n", drive->media.tracks);
	printf("   disc type: %02X\n", drive->rd_buf[8]&0xFF);
	printf("   disc ID: %02X%02X%02X%02X\n",
		drive->rd_buf[12],drive->rd_buf[13],drive->rd_buf[14],drive->rd_buf[15]);
	printf("   Last session  lead-in  start: %d:%02d.%02d\n",
		(drive->rd_buf[16]<<8)|drive->rd_buf[17],drive->rd_buf[18],drive->rd_buf[19]);
//	if (((drive->rd_buf[20]==-1) && (drive->rd_buf[21]==-1) && (drive->rd_buf[22]==-1) && (drive->rd_buf[23]==-1)) || (!drive->wr_capabilities))
//		{ drive->media.last_lead_out = 0xFFFFFFFF; }
//	else {
		drive->media.last_lead_out = (((drive->rd_buf[20]&0xFF) << 8) | (drive->rd_buf[21]&0xFF))*75*60 + ((drive->rd_buf[22]&0xFF)*75) + (drive->rd_buf[23]&0xFF);
//	}
	printf("   Last possible lead-out start: %d:%02d.%02d (sector 0x%08X)\n",
		(drive->rd_buf[20]<<8)|drive->rd_buf[21],drive->rd_buf[22],drive->rd_buf[23],drive->media.last_lead_out);

	if (!drive->media.sstatus) {
		drive->media.sessions--;
		drive->media.tracks--;
	}
	return 0;
}

void read_disc_regions(drive_info* drive){
#warning "read_disc_regions()"
	int len=4;
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_DVD_STRUCTURE;
	drive->cmd[7] = 0x01;
	drive->cmd[8] = len>>8;
	drive->cmd[9] = len;
	drive->cmd[11] = 0;
	drive->err = drive->cmd.transport(READ,drive->rd_buf,len);
}

int determine_cd_type(drive_info* drive) {
//	unsigned char*	ATIP;
//	int		ATIP_len;
//	int		i;
	int ratip = read_atip(drive);
/*	printf("ATIP_len=%d\nATIP data:",drive->ATIP_len);
	for (i=0; i< drive->ATIP_len; i++) printf("%4d",(drive->ATIP[i])&0xFF);
	printf("\n");*/
	if (!ratip) drive->ATIP_len+=4;
	// CD-RW?
	int cdrw = !!(drive->ATIP[6] & 0x40);
	int cdrw_subtype = (drive->ATIP[6] & 0x38) >> 3;
	if ((ratip) || (drive->ATIP_len < 8)) {
// 		printf("no atip found - CD-ROM\n");
		return DISC_CDROM; // CD-ROM
	} else
	if (cdrw) {
// 		printf("disc type: CD-RW\n");
		switch (cdrw_subtype) {
			case 0: return DISC_CDRW | DISC_CDRWMS; break;
			case 1: return DISC_CDRW | DISC_CDRWHS; break;
			case 2: return DISC_CDRW | DISC_CDRWUS; break;
			case 3: return DISC_CDRW | DISC_CDRWUSP; break;
		}
	} else {
		return DISC_CDR;
// 		printf("disc type: CD-R\n");
	}
	return Media_BLANK;
}

int read_mediaid_dvd(drive_info* drive){
	int		i;
	unsigned int	len;
	char		header[40];
	union { unsigned char _e[4+40],_11[4+256]; } dvd;
	unsigned char	format; // 0x11 +, 0x0E -
	if (drive->media.disc_type & DISC_DVDminus)
		format=0x0E;
	else
		format=0x11;
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_DVD_STRUCTURE;
	drive->cmd[7] = format;
	drive->cmd[9] = 4;
	drive->cmd[11] = 0;
	drive->err = drive->cmd.transport(READ,header,4);//))
	len = (header[0]<<8|header[1]) + 2;
	if (len>sizeof(dvd)) len=sizeof(dvd);
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ_DVD_STRUCTURE;
	drive->cmd[7] = format;
	drive->cmd[8] = len>>8;
	drive->cmd[9] = len;
	drive->cmd[11] = 0;
	drive->err = drive->cmd.transport(READ,&dvd,len);
	drive->media.MID[0] = 0;
	if (drive->media.disc_type & DISC_DVDminus) {
		memcpy(drive->media.MID,dvd._e+21,6);
		drive->media.MID[6]='/';
		memcpy(drive->media.MID+7,dvd._e+29,6);
		drive->media.MID[12]=0;
//		drive->media.MID[12]='/';
//		memcpy(drive->media.MID+13,dvd._e+37,6);
// 		drive->media.MID[18]=0;
	} else {
		memcpy(drive->media.MID,dvd._11+23,8);
		drive->media.MID[8]='/';
		memcpy(drive->media.MID+9,dvd._11+31,3);
		drive->media.MID[12]=0;
//		for (i=12; i<19; i++) drive->media.MID[i]=0;
	}
	for (i=0; i<12; i++) if(drive->media.MID[i] == 0) drive->media.MID[i]=0x20;
	return 0;
}

int read_mediaid_cd(drive_info* drive)
{	
//	printf("read_mediaid_cd()\n");
	msf	lin;
	int type;
	int atippr = read_atip(drive);
	if (!atippr) drive->ATIP_len+=4; else return 1;
	lin.m=drive->ATIP[8];
	lin.s=drive->ATIP[9];
	lin.f=drive->ATIP[10];
	type = lin.f % 10;
	lin.f -= type;
	int idx=0;
	int nf=1;
	while (mi[idx].lin.m && nf)
		if (lin.m == mi[idx].lin.m && lin.s == mi[idx].lin.s && lin.f == mi[idx].lin.f) nf=0;
		else idx++;
	
//	strncpy(drive->media.MID,mi[idx].name,47));
	sprintf(drive->media.MID,"[%02d:%02d.%02d] %s",lin.m,lin.s,lin.f,mi[idx].name);
	return 0;
}

int determine_disc_type(drive_info* drive) {
	int current = 0, i=0;
	drive->media.disc_type = DISC_NODISC;
// 	drive->media.type = Media_NoMedia;
	if (drive->mmc>1) {
		get_configuration(drive, FEATURE_PROFILE_LIST, NULL, &current);
		switch (drive->rd_buf[7]) {
			case 0: drive->media.disc_type = DISC_NODISC; break;
			case PROFILE_CD_ROM:		drive->media.disc_type = DISC_CDROM; break;
			case PROFILE_CD_R: 		drive->media.disc_type = DISC_CDR; break;
			case PROFILE_CD_RW:		drive->media.disc_type = DISC_CDRW; break;
			case PROFILE_DVD_ROM:		drive->media.disc_type = DISC_DVDROM; break;
			case PROFILE_DVD_R_SEQ:		drive->media.disc_type = DISC_DVDminusR; break;
			case PROFILE_DVD_RAM:		drive->media.disc_type = DISC_DVDRAM; break;
			case PROFILE_DVD_RW_RESTOV:	drive->media.disc_type = DISC_DVDminusRWR; break;
			case PROFILE_DVD_RW_SEQ:	drive->media.disc_type = DISC_DVDminusRWS; break;
			case PROFILE_DVD_R_DL_SEQ:	drive->media.disc_type = DISC_DVDminusRDL; break;
			case PROFILE_DVD_R_DL_JUMP:	drive->media.disc_type = DISC_DVDminusRDLJ; break;
			case PROFILE_DVD_PLUS_RW:	drive->media.disc_type = DISC_DVDplusRW; break;
			case PROFILE_DVD_PLUS_R:	drive->media.disc_type = DISC_DVDplusR; break;
			case PROFILE_DVD_PLUS_R_DL:	drive->media.disc_type = DISC_DVDplusRDL; break;

			default: drive->media.disc_type = DISC_UN; break;
		}
		if (!drive->media.disc_type) return 0;
		read_disc_information(drive);
		if (drive->media.disc_type & DISC_DVD) {
// 			drive->media.type=Media_DVD;
 			drive->rd_buf[4]=0;
			drive->cmd_clear();
			drive->cmd[0] = MMC_READ_DVD_STRUCTURE;
			drive->cmd[7] = 0;//0x11; //dvd_dash;
			drive->cmd[9] = 36;
			drive->cmd[11] = 0;
			if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,36))) 
				sperror ("READ_DVD_STRUCTURE",drive->err);
			drive->media.book_type = (drive->rd_buf[4] & 0xFF);
			drive->media.layers = 1 + ((drive->rd_buf[6] & 0x60) >> 5);
			read_mediaid_dvd(drive);
			printf("** MID: '%s'\n",drive->media.MID);
			if ((!(drive->wr_capabilities & DEVICE_DVD))||(drive->media.disc_type & DISC_DVDROM)) {
				printf("Device can't write DVD's or media detected as DVD-ROM,\n");
				printf("trying to corectly detect DVD type...\n");
				switch ((drive->media.book_type>>4)&0x0F){
					case BOOK_DVD_R:
						if (drive->media.layers == 1) 
							drive->media.disc_type = DISC_DVDminusR;
						else
							drive->media.disc_type = DISC_DVDminusRDL;
						break;
					case BOOK_DVD_RW:
						drive->media.disc_type = DISC_DVDminusRWS; break;
					case BOOK_DVD_PR:
						drive->media.disc_type = DISC_DVDplusR; break;
					case BOOK_DVD_PRW:
						drive->media.disc_type = DISC_DVDplusRW; break;
					case BOOK_DVD_PR_DL:
						drive->media.disc_type = DISC_DVDplusRDL; break;
					case BOOK_DVD_ROM:
						if (strncmp(drive->media.MID,"        /   ",12)) {
							printf("MID found:)\n");
							if (drive->media.erasable) {
								drive->media.disc_type = DISC_DVDplusRW;
							} else {
								if (drive->media.layers == 1)
									drive->media.disc_type = DISC_DVDplusR;
								else
									drive->media.disc_type = DISC_DVDplusRDL;
							}
						}
						break;
					default:
						break;
				}
			}
			read_writer_info(drive);
			printf("** Writer used: '%s'\n",drive->media.writer);
			read_disc_regions(drive);
			printf("DVD Copyright info: ");
			for (i=0;i<4;i++) printf("0x%02X ",drive->rd_buf[i]);
			printf("\n");
			return 0;
		} else if (drive->media.disc_type & DISC_CD) {
// 			drive->media.type=Media_CD;
	//		plextor_set_hidecdr(drive, 0);
			drive->media.disc_type |= determine_cd_type(drive);
			read_mediaid_cd(drive);
			printf("** MID: '%s'\n",drive->media.MID);
			return 0;
		}
	} else {
		read_capacity(drive);
		if (drive->media.capacity) {
// 			drive->media.type=Media_CD;
			drive->media.disc_type = DISC_CDROM;
			read_disc_information(drive);
		}
		return 0;
	}
	return 1;
}

int get_spindown(drive_info* drive) {
	mode_sense(drive, 0x0D, 00, 192);
	if (drive->err)
		{drive->parms.spindown_idx=spindowns; return (drive->err);}
	drive->parms.spindown_idx = drive->rd_buf[11] & 0x0F;
	return 0;
}

int set_spindown(drive_info* drive) {
	int	i;
	for (i=0; i<16; i++) drive->rd_buf[i]=0;
	drive->rd_buf[8] = 0x0D;
	drive->rd_buf[9] = 0x06;
	drive->rd_buf[11] = drive->parms.spindown_idx & 0x0F;
	drive->rd_buf[13] = 0x3C;
	drive->rd_buf[15] = 0x4B;
	mode_select(drive, 16);
	return 0;
}


//	int j = ExecSCSICmd(SRB_DIR_IN,drive,&srbExec,data,1024,12,
//	0xAC,(read)?0:(type==0)?4:0, 0,0,
//	0,0,0,0,
//	0,50,type,0);

int get_performance(drive_info* drive) {
	const int max_descs=52;
	const int desc_len=16;
	int	len, descn;
//	int	i;
	int	j,offs;
	drive->cmd_clear();
	drive->cmd[0] = MMC_GET_PERFORMANCE;
	drive->cmd[1] = 0x00;
	drive->cmd[8] = (max_descs >> 8) & 0xFF;
	drive->cmd[9] = max_descs & 0xFF;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf, 1024)))
		{ sperror ("GET_PERFORMANCE",drive->err); return (drive->err); }
//	return 1;
	len = (drive->rd_buf[0]<<24) | (drive->rd_buf[1]<<16) | (drive->rd_buf[2]<<8) | (drive->rd_buf[3]);
	descn = len/desc_len;
//	printf("Performance data length: %d; decriptors: %d\n",len, descn);

//	printf("GET_PERFORMANCE response dump:\n");
//	for (j=0; j*8<len; j++) {
//		for (i=0; i<8; i++) printf(" 0x%02X",drive->rd_buf[i]);
//		printf("\n");
//	}
	for (j=0; j<descn; j++) {
		offs = 8+j*desc_len;
		printf("\tDescriptor #%02d:",j);
//		for (i=0; i<desc_len; i++)  printf(" 0x%02X",(drive->rd_buf[offs+i])&0xFF);
//		printf("\n");
		drive->perf.lba_s = ((drive->rd_buf[offs]<<24)&0xFF000000) | ((drive->rd_buf[offs+1]<<16)&0xFF0000) |
			 ((drive->rd_buf[offs+2]<<8)&0xFF00) | ((drive->rd_buf[offs+3])&0xFF);
		offs = 8+j*desc_len+4;
		drive->perf.spd_s = ((drive->rd_buf[offs]<<24)&0xFF000000) | ((drive->rd_buf[offs+1]<<16)&0xFF0000) |
			 ((drive->rd_buf[offs+2]<<8)&0xFF00) | ((drive->rd_buf[offs+3])&0xFF);
		offs = 8+j*desc_len+8;
		drive->perf.lba_e = ((drive->rd_buf[offs]<<24)&0xFF000000) | ((drive->rd_buf[offs+1]<<16)&0xFF0000) |
			 ((drive->rd_buf[offs+2]<<8)&0xFF00) | ((drive->rd_buf[offs+3])&0xFF);
		offs = 8+j*desc_len+12;
		drive->perf.spd_e = ((drive->rd_buf[offs]<<24)&0xFF000000) | ((drive->rd_buf[offs+1]<<16)&0xFF0000) |
			 ((drive->rd_buf[offs+2]<<8)&0xFF00) | ((drive->rd_buf[offs+3])&0xFF);
		printf("\t%dkB/s@%d -> %dkB/s@%d\n",
			drive->perf.spd_s,drive->perf.lba_s,drive->perf.spd_e,drive->perf.lba_e);
	}
	return 0;
}

int get_write_speed(drive_info* drive) {
	int	offs;
	mode_sense(drive, 0x2A, 00, 256);
	offs=0; while (((drive->rd_buf[offs]) & 0x3F) != 0x2A) offs++;
	drive->parms.write_speed_kb = swap2(drive->rd_buf+offs+28);
	return 0;
}

int get_write_speed_tbl(drive_info* drive) {
	int	offs;
	int	i, spdcnt;
	mode_sense(drive, 0x2A, 00, 256);
	offs=0; while (((drive->rd_buf[offs]) & 0x3F) != 0x2A) offs++;
//	drive->parms.write_speed_kb = swap2(drive->rd_buf+offs+28);
	spdcnt = swap2(drive->rd_buf+offs+30);
	for (i=0; i<speed_tbl_size;i++)
		drive->parms.wr_speed_tbl_kb[i] = 0;
//	printf("== Write speeds: %d\n",spdcnt);
	for (i=0; (i<spdcnt) && (i<speed_tbl_size); i++) {
		drive->parms.wr_speed_tbl_kb[i] = swap2(drive->rd_buf+offs+32+i*4+2);
//		printf("  Speed #%02d: %d kB/s\n",i,drive->parms.wr_speed_tbl_kb[i]);
	}
	return 0;
}

int get_read_speed(drive_info* drive) {
	int	offs;
	mode_sense(drive, 0x2A, 00, 256);
	offs=0; while (((drive->rd_buf[offs]) & 0x3F) != 0x2A) offs++;
	drive->parms.read_speed_kb = swap2(drive->rd_buf+offs+14);
	return 0;
}

int set_streaming(drive_info* drive) {
	char data[28]; memset(data, 0, 28);

	int* start_lba  = (int*)&data[4];
	int* end_lba    = (int*)&data[8];
	int* read_size  = (int*)&data[12];
	int* read_time  = (int*)&data[16];
	int* write_size = (int*)&data[20];
	int* write_time = (int*)&data[24];

	read_capacity(drive);

	*start_lba = swap4(0);
	*end_lba = swap4(drive->media.capacity);
//	*end_lba = swap4(0);
	*read_time = swap4(1000);
	*read_size = swap4(drive->parms.read_speed_kb);
	*write_time = swap4(1000);
	*write_size = swap4(drive->parms.write_speed_kb);
	drive->cmd_clear();
	drive->cmd[0] = MMC_SET_STREAMING;
	drive->cmd[10] = 28;
	if ((drive->err=drive->cmd.transport(WRITE,data,28)))
		{sperror ("SET_STREAMING",drive->err); return (drive->err); }
	return 0;
}

int set_cd_speed(drive_info* drive) {
	int	speed = 0xFFFF;
	int	speed_wr = 0xFFFF;
	if (drive->parms.read_speed_kb) speed = drive->parms.read_speed_kb;
	if (drive->parms.write_speed_kb) speed_wr = drive->parms.write_speed_kb;

	drive->cmd_clear();
	drive->cmd[0] = MMC_SET_SPEED;
	drive->cmd[1] = 0x01;
	drive->cmd[2] = (speed >> 8) & 0xFF;
	drive->cmd[3] = speed & 0xFF;
//	drive->cmd[4] = 0xFF;
//	drive->cmd[5] = 0xFF;
	drive->cmd[4] = (speed_wr >> 8) & 0xFF;
	drive->cmd[5] = speed_wr & 0xFF;
	if ((drive->err=drive->cmd.transport(WRITE,NULL,0) )) {
//		if (drive->err != 0x23A02) drive->capabilities&=(NCAP_SET_CD_SPEED);
//		sperror ("SET_CD_SPEED",drive->err);
		return (drive->err);
	}
	return 0;
}

//#define __STREAMING_PRIOR
int set_read_speed(drive_info* drive) {
	int	rez=0;
	if ((rez = set_cd_speed(drive)))
		rez = set_streaming(drive);
/*
#ifdef __STREAMING_PRIOR
	if (drive->media.disc_type & DISC_CD) {
		rez = set_cd_speed(drive);
	} else if (drive->media.disc_type & DISC_DVD) {
		{ if ((rez = set_cd_speed(drive))) rez = set_streaming(drive); }
	}
#else
	if ((drive->capabilities & CAP_SET_CD_SPEED) )//&& (drive->media.disc_type & DISC_CD))
		{ if ((rez = set_cd_speed(drive))) rez = set_streaming(drive); }
	else if (drive->capabilities & CAP_REAL_TIME_STREAMING)
		{ rez = set_streaming(drive); }
#endif*/
	return rez;
}

int get_media_status(drive_info* drive){
	drive->cmd_clear();
	drive->cmd[0]=MMC_GET_EVENT_STATUS_NOTIFICATION;
	drive->cmd[1]=0x01;
	drive->cmd[4]=0x10;
	drive->cmd[7]=0;
	drive->cmd[8]=8;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,8)))
		{ sperror ("GET_EVENT_STATUS",drive->err); return (drive->err); }
	if (drive->rd_buf[5] & 0x01) drive->parms.status |= STATUS_OPEN;
	else drive->parms.status &= (~STATUS_OPEN);
	if (drive->rd_buf[5] & 0x02) drive->parms.status |= STATUS_MEDIA_PRESENT;
	else drive->parms.status &= (~STATUS_MEDIA_PRESENT);
	return 0;
}

int load_eject(drive_info* drive, bool load){
	drive->cmd_clear();
	drive->cmd[0]=MMC_START_STOP_UNIT;
	drive->cmd[4]=0x02 | load;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,0)))
		{ sperror ("LOAD_EJECT",drive->err); return (drive->err); }
	return 0;
}

int get_lock(drive_info* drive){
//	printf("get_lock()\n");
	int offs;
	if (mode_sense(drive, 0x2A, 0, 256)) 
		{ sperror ("GET_LOCK",drive->err); return (drive->err); }
	offs=0; while (((drive->rd_buf[offs]) & 0x3F) != 0x2A) offs++;
	if (drive->rd_buf[offs+6] & 0x02) drive->parms.status |= STATUS_LOCK;
	else drive->parms.status &= (~STATUS_LOCK);
	printf("--- Disc %slocked\n",(drive->parms.status & STATUS_LOCK) ? "" : "UN");
	return 0;
}

int set_lock(drive_info* drive){
	int lock;
//	printf("--- %slocking disc...\n",(drive->parms.status & STATUS_LOCK) ? "" : "UN");
	if (drive->parms.status & STATUS_LOCK) lock=1; else lock=0;	
	drive->cmd_clear();
	drive->cmd[0]=MMC_PREVENT_ALLOW_MEDIUM_REMIVAL;
	drive->cmd[4]=lock;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,0)))
		{ sperror ("SET_LOCK",drive->err); get_lock(drive); return (drive->err); }
	get_lock(drive);
	return 0;
}

int play_audio_msf(drive_info* drive, int beg, int end){
	drive->cmd_clear();
	drive->cmd[0]=MMC_PLAY_AUDIO_MSF;
	drive->cmd[3]=(beg>>16) & 0xFF;
	drive->cmd[4]=(beg>>8) & 0xFF;
	drive->cmd[5]=beg & 0xFF;
	drive->cmd[6]=(end>>16) & 0xFF;
	drive->cmd[7]=(end>>8) & 0xFF;
	drive->cmd[8]=end & 0xFF;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,0)))
		{ sperror ("PLAY_AUDIO_MSF",drive->err); return (drive->err); }
	return 0;
}

int play_audio(drive_info* drive, int beg, short int len){
	drive->cmd_clear();
	drive->cmd[0]=MMC_PLAY_AUDIO;
	drive->cmd[2]=(beg>>24) & 0xFF;
	drive->cmd[3]=(beg>>16) & 0xFF;
	drive->cmd[4]=(beg>>8) & 0xFF;
	drive->cmd[5]=beg & 0xFF;
	drive->cmd[7]=(len>>8) & 0xFF;
	drive->cmd[8]=len & 0xFF;
	if ((drive->err=drive->cmd.transport(WRITE,drive->rd_buf,0)))
		{ sperror ("PLAY_AUDIO",drive->err); return (drive->err); }
	return 0;
}

int read_cd(drive_info* drive, int lba, int sector_count) {
	int transfer_length = sector_count * 3072;
	drive->cmd_clear();
	drive->cmd[0]=MMC_READ_CD;
	drive->cmd[2]=(lba>>24) & 0xFF;
	drive->cmd[3]=(lba>>16) & 0xFF;
	drive->cmd[4]=(lba>>8) & 0xFF;
	drive->cmd[5]=lba & 0xFF;
	drive->cmd[8]=sector_count;
	drive->cmd[9]=0xFA;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,transfer_length)))
		{ sperror ("READ_CD",drive->err); return (drive->err); }
	return 0;
}

int read(drive_info* drive, int lba, int sector_count) {
	int transfer_length = sector_count * 3072;
	drive->cmd_clear();
	drive->cmd[0]=MMC_READ;
	drive->cmd[2]=(lba>>24) & 0xFF;
	drive->cmd[3]=(lba>>16) & 0xFF;
	drive->cmd[4]=(lba>>8) & 0xFF;
	drive->cmd[5]=lba & 0xFF;
	drive->cmd[8]=sector_count;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,transfer_length)))
		{sperror ("READ",drive->err); return (drive->err);}
	return 0;
}

int read_one_ecc_block(drive_info* drive, int lba) {
	drive->cmd_clear();
	drive->cmd[0] = MMC_READ;
	drive->cmd[2] = (lba>>24) & 0xFF;
	drive->cmd[3] = (lba>>16) & 0xFF;
	drive->cmd[4] = (lba>>8) & 0xFF;
	drive->cmd[5] = lba & 0xFF;
	drive->cmd[8] = 0x10;
	if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,0x8000)))
		{sperror ("READ_ONE_ECC_BLOCK",drive->err); return (drive->err);}
//	if ((drive->err=drive->cmd.transport(READ,(void*)((unsigned char*)drive->rd_buf+(0x0001<<14)),0x34)))
//		{sperror ("READ_ONE_ECC_BLOCK",drive->err); return (drive->err);}
	return 0;
}

int get_drive_serial_number(drive_info* drive) {
//	char data[2048]; memset(data, 0, sizeof(data));
	char data_length;
	int length;
	get_configuration(drive, FEATURE_LOGICAL_UNIT_SERIAL_NUMBER, &data_length, NULL);
	length = drive->rd_buf[11]; drive->rd_buf[12+length]=0;
	if (data_length>8) strncpy(drive->serial, (char*)drive->rd_buf+12, 16);
	else drive->serial[0]=0;
	return 1;
}

int read_buffer_capacity(drive_info* drive){
	if (mode_sense(drive, 0x2A, 0, 192)) return 1;
	drive->buffer_size=((drive->rd_buf[20] & 0xFF) << 8 ) | (drive->rd_buf[21] & 0xFF);
	printf("Buffer capacity: 0x%04X (%d)KB\n", drive->buffer_size, drive->buffer_size);
	return 0;
}

int read_writer_info(drive_info* drive)
{
	if (!(drive->media.disc_type & (DISC_DVDminusR | DISC_DVDminusRWS | DISC_DVDminusRWR))) {
		strcpy(drive->media.writer, "n/a (only for DVD-R(W))");
		return 1;
	}
	char format=0x0D;
	drive->media.writer[0]=0;
	drive->rd_buf[8]=0;
	drive->cmd_clear();
	drive->cmd[0]=MMC_READ_DVD_STRUCTURE;
	drive->cmd[5]=0x62;
	drive->cmd[7]=format;
	drive->cmd[8]=8;
	drive->cmd[9]=8;
	if ((drive->err = drive->cmd.transport(READ,drive->rd_buf,2056)) || (!drive->rd_buf[8])) {
		printf("Read Writer Info Method 1 failed\n");
		drive->cmd_clear();
		drive->cmd[0]=MMC_READ_DVD_STRUCTURE;
		drive->cmd[5]=0x02;
		drive->cmd[7]=format;
		drive->cmd[8]=8;
		drive->cmd[9]=8;
		if ((drive->err=drive->cmd.transport(READ,drive->rd_buf,2056))) {
			printf("Read Writer Info Method 2 failed\n");
			return 1;
		}
	}
	for (int k=0;k<0x3F;k++) {
		if (!drive->rd_buf[8+k]) drive->rd_buf[8+k]=0x20;
	}
	strncpy(drive->media.writer, (char*)drive->rd_buf+8, 0x3F);
	remove_double_spaces(drive->media.writer);
//	remove_end_spaces(drive->media.writer);
	return 0;
}

int detect_mm_capabilities(drive_info* drive){
	char len;
	int i,j;
	int offs;
	if (mode_sense(drive, 0x2A, 0, 256)) return 1;
	offs=0; while (((drive->rd_buf[offs]) & 0x3F) != 0x2A) offs++;
	len=drive->rd_buf[offs+1];
	printf("CD parameters page length: 0x%02X\n",len);
	if (len >= 28) {drive->mmc=3;}
	else if (len >= 24) {drive->mmc=2;}
	else {drive->mmc=1;}
	for (i=offs; i<(offs+len+2);i+=8){
		for (j=0;j<8;j++) printf(" %02X",drive->rd_buf[i+j] & 0xFF);
		printf("\n");
	}
//	if (drive->mmc) drive->rd_capabilities|=DEVICE_CD_ROM;
	if (drive->rd_buf[offs+2] & 0x01)drive->rd_capabilities|=DEVICE_CD_R;
	if (drive->rd_buf[offs+2] & 0x02)drive->rd_capabilities|=DEVICE_CD_RW;

	if (drive->rd_buf[offs+3] & 0x01)drive->wr_capabilities|=DEVICE_CD_R;
	if (drive->rd_buf[offs+3] & 0x02)drive->wr_capabilities|=DEVICE_CD_RW;
	if (drive->rd_buf[offs+3] & 0x04)drive->capabilities|=CAP_TEST_WRITE;

	if (drive->rd_buf[offs+4] & 0x01)drive->capabilities|=CAP_CD_AUDIO;
	if (drive->rd_buf[offs+4] & 0x02)drive->capabilities|=CAP_COMPOSITE;
	if (drive->rd_buf[offs+4] & 0x04)drive->capabilities|=CAP_DIGITAL_PORT_1;
	if (drive->rd_buf[offs+4] & 0x08)drive->capabilities|=CAP_DIGITAL_PORT_2;
	if (drive->rd_buf[offs+4] & 0x10)drive->capabilities|=CAP_MODE2_FORM1;
	if (drive->rd_buf[offs+4] & 0x20)drive->capabilities|=CAP_MODE2_FORM2;
	if (drive->rd_buf[offs+4] & 0x40)drive->capabilities|=CAP_MULTISESSION;

	if (drive->rd_buf[offs+5] & 0x01)drive->capabilities|=CAP_DAE;
	if (drive->rd_buf[offs+5] & 0x02)drive->capabilities|=CAP_ACCURATE_STREAM;
	if (drive->rd_buf[offs+5] & 0x10)drive->capabilities|=CAP_C2;
	if (drive->rd_buf[offs+5] & 0x20)drive->capabilities|=CAP_ISRC;
	if (drive->rd_buf[offs+5] & 0x40)drive->capabilities|=CAP_UPC;
	if (drive->rd_buf[offs+5] & 0x80)drive->capabilities|=CAP_READ_BAR_CODE;	

	if (drive->rd_buf[offs+6] & 0x01)drive->capabilities|=CAP_LOCK;
	if (drive->rd_buf[offs+6] & 0x08)drive->capabilities|=CAP_EJECT;

	drive->loader_id = (drive->rd_buf[offs+6] >> 5) & 0x07;

	if (drive->rd_buf[offs+7] & 0x10)drive->capabilities|=CAP_SIDE_CHANGE;

	switch (drive->mmc) {
		case 3:
			drive->parms.write_speed_kb=drive->rd_buf[37] << 8 | drive->rd_buf[36];
		case 2:
			if (drive->rd_buf[offs+2] & 0x08)drive->rd_capabilities|=DEVICE_DVD_ROM;
			if (drive->rd_buf[offs+2] & 0x10)drive->rd_capabilities|=DEVICE_DVD_R;
			if (drive->rd_buf[offs+2] & 0x20)drive->rd_capabilities|=DEVICE_DVD_RAM;
			if (drive->rd_buf[offs+3] & 0x10)drive->wr_capabilities|=DEVICE_DVD_R;
			if (drive->rd_buf[offs+3] & 0x20)drive->wr_capabilities|=DEVICE_DVD_RAM;
//			break;
		case 1:
			drive->parms.max_read_speed_kb=drive->rd_buf[offs+9] <<8 | drive->rd_buf[offs+8];
			drive->parms.read_speed_kb=drive->rd_buf[offs+15] <<8 | drive->rd_buf[offs+14];
			drive->parms.max_write_speed_kb=drive->rd_buf[offs+19] <<8 | drive->rd_buf[offs+19];
			drive->parms.write_speed_kb=drive->rd_buf[offs+21] << 8 | drive->rd_buf[offs+20];
			break;
	}

	printf("Max speeds:\tR@%dKBps / W@%dKBps\nCurrent speeds:\tR@%dKBps / W@%dKBps\n",
		drive->parms.max_read_speed_kb, drive->parms.max_write_speed_kb,
		drive->parms.read_speed_kb, drive->parms.write_speed_kb);
	return 0;
}

int convert_to_ID (drive_info* drive) {
	if (!strncmp(drive->ven,"PLEXTOR ",8)) {
		drive->ven_ID=WR_PLEXTOR;
		if(!strncmp(drive->dev,"CD-R   PREMIUM",14))
			drive->dev_ID=PLEXTOR_PREMIUM;
		else
		if(!strncmp(drive->dev,"DVD-ROM PX-130",14))
			{ drive->ven_ID=RD_BENQ;
			drive->dev_ID=BENQ_DV1650V;}
		else
		if(!strncmp(drive->dev,"DVDR   PX-708A2",15))
			drive->dev_ID=PLEXTOR_708A2;
		else
		if(!strncmp(drive->dev,"DVDR   PX-712",13))
			drive->dev_ID=PLEXTOR_712;
		else
		if(!strncmp(drive->dev,"DVDR   PX-714",13))
			drive->dev_ID=PLEXTOR_716;
		else
		if(!strncmp(drive->dev,"DVDR   PX-716",13))
			drive->dev_ID=PLEXTOR_716;
		else
/*		if(!strncmp(drive->dev,"DVDR   PX-740",13))
			{ drive->ven_ID=WR_BENQ;
			drive->dev_ID=BENQ_DW1640;}
		else*/
/*		if(!strncmp(drive->dev,"DVDR   PX-750",13))
		else*/
		if(!strncmp(drive->dev,"DVDR   PX-755",13))
			drive->dev_ID=PLEXTOR_760;
		else
		if(!strncmp(drive->dev,"DVDR   PX-760",13))
			drive->dev_ID=PLEXTOR_760;
		else
			drive->dev_ID=PLEXTOR_OLD;
//			{ drive->ven_ID = WR_GENERIC; drive->dev_ID = 0; }
	}
	else if (!strncmp(drive->ven,"PIONEER ",8)) {
		drive->ven_ID=WR_PIONEER;
		if(!strncmp(drive->dev,"DVD-RW  DVR-106",15))
			drive->dev_ID=PIO_DVR_106;
		else
		if(!strncmp(drive->dev,"DVD-RW  DVR-107",15))
			drive->dev_ID=PIO_DVR_107;
		else
		if(!strncmp(drive->dev,"DVD-RW  DVR-108",15))
			drive->dev_ID=PIO_DVR_108;
		else
		if(!strncmp(drive->dev,"DVD-RW  DVR-109",15))
			drive->dev_ID=PIO_DVR_109;
		else
		if(!strncmp(drive->dev,"DVD-RW  DVR-110",15))
			drive->dev_ID=PIO_DVR_110;
		else
		if(!strncmp(drive->dev,"DVD-RW  DVR-111",15))
			drive->dev_ID=PIO_DVR_111;
		else
			drive->dev_ID=PIO_OLD;
//			{ drive->ven_ID = WR_GENERIC; drive->dev_ID = 0; }
	}
	else if (!strncmp(drive->ven,"ASUS    ",8)) {
		drive->ven_ID=WR_PIONEER;
		drive->dev_ID=PIO_OLD;
	}
	else if (!strncmp(drive->ven,"_NEC    ",8)) {
		drive->ven_ID=WR_NEC;
		if(!strncmp(drive->dev,"DVD_RW ND-352",13))
			drive->dev_ID=NEC_3520;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-353",13))
			drive->dev_ID=NEC_3530;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-354",13))
			drive->dev_ID=NEC_3540;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-355",13))
			drive->dev_ID=NEC_4550;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-357",13))
			drive->dev_ID=NEC_4570;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-365",13))
			drive->dev_ID=NEC_4650;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-455",13))
			drive->dev_ID=NEC_4550;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-457",13))
			drive->dev_ID=NEC_4570;
		else
		if(!strncmp(drive->dev,"DVD_RW ND-465",13))
			drive->dev_ID=NEC_4650;
		else
			drive->dev_ID=NEC_OLD;
//			{ drive->ven_ID = WR_GENERIC; drive->dev_ID = 0; }
	}

	else if (!strncmp(drive->ven,"LITE-ON ",8)) {
		drive->ven_ID=WR_LITEON;
		if(!strncmp(drive->dev,"LTR-52327S",10))
			drive->dev_ID=LTN_LTR_52327;
		else
		if(!strncmp(drive->dev,"DVDRW SOHW-812S",14))
			drive->dev_ID=LTN_SOHW_812S;
		else
		if(!strncmp(drive->dev,"DVDRW SOHW-832S",14))
			drive->dev_ID=LTN_SOHW_832S;
		else
			drive->dev_ID=LTN_OLD;
	}

	else if (!strncmp(drive->ven,"BENQ    ",8)) {
		drive->ven_ID=WR_BENQ;
		if(!strncmp(drive->dev,"DVD DD DW1620",13))
			drive->dev_ID=BENQ_DW1620;
		else
		if(!strncmp(drive->dev,"DVD DD DW1640",13))
			drive->dev_ID=BENQ_DW1640;
		else
			drive->dev_ID=BENQ_OLD;
	}

/*
	else if (!strncmp(drive->ven,"TEAC    ",8)) {
	}
*/

	else if (!strncmp(drive->ven,"SONY    ",8)) {
		drive->ven_ID=WR_LITEON;
		if(!strncmp(drive->dev,"DVD RW DRU-700A",15))
			drive->dev_ID=LTN_SOHW_832S;
		else
			drive->dev_ID=LTN_OLD;
	}

	else { drive->ven_ID = WR_GENERIC; drive->dev_ID = 0; }
	return 0;
}

int detect_check_capabilities(drive_info* drive){
	drive->chk_features=0;
	switch (drive->ven_ID) {
		case WR_PLEXTOR:
			switch (drive->dev_ID) {
				case PLEXTOR_760:
				case PLEXTOR_716:
					drive->chk_features|=CHK_TA;
				case PLEXTOR_712:
				case PLEXTOR_708A2:
					drive->chk_features|=CHK_JB_DVD;
					drive->chk_features|=CHK_PI;
					drive->chk_features|=CHK_PO;
				case PLEXTOR_PREMIUM:
					drive->chk_features|=CHK_JB_CD;
					drive->chk_features|=CHK_CX;
					drive->chk_features|=CHK_FETE;
			}
			break;
		case WR_PIONEER:
			if (drive->rd_capabilities & DEVICE_DVD) {
				drive->chk_features|=CHK_PIE;
				drive->chk_features|=CHK_PIF;
			}
			break;
		case WR_NEC:
			drive->chk_features|=CHK_CX;
			drive->chk_features|=CHK_PIE;
			drive->chk_features|=CHK_PIF;
			break;
		case WR_LITEON:
			drive->chk_features|=CHK_CX;
//			drive->chk_features|=CHK_JB_CD;
			if (drive->rd_capabilities & DEVICE_DVD) {
				drive->chk_features|=CHK_PIE;
				drive->chk_features|=CHK_PIF;
//				drive->chk_features|=CHK_JB_DVD;
			}
			break;
		case RD_BENQ:
			drive->chk_features|=CHK_CX;
			drive->chk_features|=CHK_JB_CD;
			if (drive->rd_capabilities & DEVICE_DVD) {
				drive->chk_features|=CHK_PIE;
				drive->chk_features|=CHK_PIF;
				drive->chk_features|=CHK_JB_DVD;
			}
			break;
		case WR_BENQ:
			drive->chk_features|=CHK_CX;
//			drive->chk_features|=CHK_JB_CD;
//			if (drive->rd_capabilities & DEVICE_DVD) {
				drive->chk_features|=CHK_PIE;
				drive->chk_features|=CHK_PIF;
//				drive->chk_features|=CHK_JB_DVD;
//			}
			break;
		case WR_GENERIC:
// 			if (drive->capabilities | CAP_C2)
// 				drive->chk_features|=CHK_CX;
			break;
		default:
			break;
	}
	return 0;
}
